# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Defined types**

* [`download_uncompress`](#download_uncompress): Downloads and possibly uncompress a file from a given url to a specified   destination folder.

## Defined types

### download_uncompress

Downloads and possibly uncompress a file from a given url to a specified
  destination folder.

#### Examples

##### Declaring in manifest

```puppet
download_uncompress {'dwnl_inst_swxy':
  download_base_url  => 'http://jee.invallee.it/dist',
  distribution_name  => 'SoftwareXY.zip',
  dest_folder   => '/tmp',
  creates       => '/tmp/SXYInstallFolder',
  uncompress    => 'tar.gz',
}
```

#### Parameters

The following parameters are available in the `download_uncompress` defined type.

##### `download_base_url`

Data type: `Optional[String]`

base URL from which to download.
Defaults to <tt>distributions_base_url</tt> key defined
in hiera or <tt>undef</tt> if such key is not found.

Default value: lookup('distributions_base_url', String, 'first', undef)

##### `distribution_name`

Data type: `String`

name of the distribution to download or
full URL, in which case the parameter $download_base_url is ignored.

##### `dest_folder`

Data type: `String`

destination folder where to unzip (or possibly only
download) the distribution.

##### `creates`

Data type: `Optional[String]`

folder created after downloading and possibly unzipping,
useful to make the resource type idempotent.
Defaults to undef in which case the parameter +refreshonly+ better would be true.

Default value: `undef`

##### `uncompress`

Data type: `Enum['none', 'zip', 'tar.gz', 'jar']`

compression type used by the distribution or
+none+ if no uncompression is needed.
Defaults to +none+.

Default value: 'none'

##### `user`

Data type: `String`

user to be used when performing the download and the
eventual uncompression.
Defaults to +root+.

Default value: root

##### `group`

Data type: `String`

group to be used when performing the download and the
eventual uncompression.
Defaults to +root+.

Default value: root

##### `wget_options`

Data type: `String`

options to pass to the wget command.
Defaults to the empty string.

Default value: ''

##### `install_unzip`

Data type: `Boolean`

whether to install the package unzip if missing.
Defaults to +true+.

Default value: `true`

##### `refreshonly`

Data type: `Boolean`

Boolean if set to true, the exec performing download and uncompress tasks will only run when
download_uncompress receives an event.
Defaults to +false+.

Default value: `false`

